/* DSTART                                                                    */
/*                                                                           */
/*           maildrop - mail delivery agent with filtering abilities         */
/*                                                                           */
/*  Copyright 1998-1999, Double Precision Inc.                               */
/*                                                                           */
/*  This program is distributed under the terms of the GNU General Public    */
/*  License. See COPYING for additional information.                         */
/* DEND                                                                      */
#include	"autoconf.h"
#if	HAVE_UNISTD_H
#include	<unistd.h>
#endif
#include	<iostream.h>
#include	<fstream.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<gdbm.h>
#include	"gdbmobj.h"
#include	"buffer.h"

static const char rcsid[]="$Id: makegdbm.C,v 1.1 1999/02/17 05:33:14 mrsam Exp $";

void outofmem()
{
	cerr << "Out of memory." << endl;
	exit(1);
}

static void addgdbm(Buffer &b, GdbmObj &o)
{
char	*p;
char	*key, *val;

	b += '\0';
	p=strdup ( (const char *)b );
	if (!p)	outofmem();
	if (!*p || *p == '#')
	{
		free(p);
		return;
	}
	key=strtok(p, "\t");
	val=strtok(NULL, "");
	if (!key)	key="";
	if (!val)	val="";
	if (*key)
	{
		if (!*val)	val="1";
		if (o.Store(key, strlen(key), val, strlen(val), "R"))
		{
			cerr << "Cannot store in GDBM file." << endl;
			exit(1);
		}
	}
	free(p);
}

static void buildgdbm(istream &i, GdbmObj &o)
{
Buffer	b;
char	buf[80];

	b.reset();
	for (;;)
	{
		if (i.eof())
		{
			addgdbm(b, o);
			break;
		}
		if (i.fail())
		{
			cerr << "Error reading textfile." << endl;
			exit(1);
		}
		i.get(buf, sizeof(buf)-1, '\n');
		if (i.peek() == '\n')
		{
			i.get();
			b.append(buf, strlen(buf));
			addgdbm(b, o);
			b.reset();
		}
		else	b.append(buf, strlen(buf));
	}
}

int main(int argc, char **argv)
{
ifstream	ifs;

	if (argc < 4)
	{
		cerr << "Usage: " << argv[0] << " textfile tmpfile gdbmfile"
			<< endl;
		exit(1);
	}
	ifs.open(argv[1]);
	if (ifs.fail())
	{
		cerr << "Unable to open " << argv[1] << endl;
		exit(1);
	}

GdbmObj gdbmfile;

	if (gdbmfile.Open(argv[2], "N"))
	{
		cerr << "Unable to create " << argv[2] << endl;
		exit (1);
	}

	buildgdbm(ifs, gdbmfile);
	gdbmfile.Close();
	rename(argv[2], argv[3]);
	return (0);
}
