/*
** $Id: rfc2045xdump.c,v 1.1 1999/01/04 05:14:12 mrsam Exp $
*/
#include	<stdio.h>
#include	"rfc2045.h"

#define	DUMP(s,n) if ( (s) ) { printf("%*s%s: %s\n", level*4, "", n, (s)); }

/* Extended RFC2045 dump */

static void dodump(struct rfc2045 *p, int level)
{
	if (!p->isdummy)
	{
		printf("%*sMessage start %ld, end %ld, startbody %ld, endbody %ld.\n", level*4,
			"", p->startpos, p->endpos, p->startbody, p->endbody);
		DUMP(p->mime_version, "Mime-Version")
		DUMP(p->content_type, "Content-Type")
		DUMP(p->charset, "Charset")
		DUMP(p->content_transfer_encoding, "Transfer Encoding")
		DUMP(p->content_boundary, "Boundary")
		DUMP(p->content_disposition, "Content Disposition")
		DUMP(p->content_disposition_name, "Disposition Name")
		DUMP(p->content_disposition_filename, "Disposition Filename")
	}

	for (p=p->firstpart; p; p=p->next)
	{
		printf("%*s{\n", level*4, "");
		dodump(p, level+1);
		printf("%*s}\n", level*4, "");
	}
}

void rfc2045_xdump(struct rfc2045 *p)
{
	dodump(p, 0);
}
