/*
** $Id: rfc822_getaddr.c,v 1.2 1999/01/06 03:51:44 mrsam Exp $
*/
#include	"rfc822.h"
#include	<stdlib.h>

static size_t addrbuflen;
static char	*addrbuf;

static void cntlen(char c)
{
	if (c != '\n')
		++addrbuflen;
}

static void saveaddr(char c)
{
	if (c != '\n')
		addrbuf[addrbuflen++]=c;
}

char *rfc822_getaddr(const struct rfc822 *rfc, int n)
{
	addrbuflen=0;
	rfc822_praddr(rfc, n, &cntlen);
	if (!(addrbuf=malloc(addrbuflen+1)))
		return (0);

	addrbuflen=0;
	rfc822_praddr(rfc, n, &saveaddr);
	addrbuf[addrbuflen]=0;
	return (addrbuf);
}

char *rfc822_getname(const struct rfc822 *rfc, int n)
{
char	*p, *q;

	addrbuflen=0;
	rfc822_prname(rfc, n, &cntlen);
	if (!(addrbuf=malloc(addrbuflen+1)))
		return (0);

	addrbuflen=0;
	rfc822_prname(rfc, n, &saveaddr);
	addrbuf[addrbuflen]=0;

	/* Get rid of surrounding quotes */

	for (p=q=addrbuf; *p; p++)
		if (*p != '"')	*q++=*p;
	*q=0;
	return (addrbuf);
}


